//-------------------- demo ------------------------------------//
#include <vcl.h>
#pragma hdrstop

#include <stdio.h>
#include "Unit1.h"
#include <winsock2.h>
#include "..\..\Include\TCPDAQ.H"

#define DEFAULT_PORT 502
//-------- Set timeout value ------
int     iConnectionTimeout=2000;
int     iSendTimeout=2000;
int     iReceiveTimeout=2000;

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------


void __fastcall TForm1::btnReadClick(TObject *Sender)
{
        int          i,j;
        int          ReturnValue,DLLVersion;
        WORD         wStartAddress;
        WORD         wCount;
        WORD         wData[64];
        char         ch[80];
        AnsiString   s1;
        TEdit        *pEdit;

        //--- Connect to EX-9000MTCP ---
        ReturnValue=TCP_Connect(edtIPAddress->Text.c_str(),DEFAULT_PORT,iConnectionTimeout, iSendTimeout, iReceiveTimeout);
        if( ReturnValue<0 )
        {
           sprintf(ch,"TCP_Connect() Failure!, Error Code:%d",ReturnValue);
           MessageBox(NULL, ch, "EX-9000MTCP demo", MB_OK+MB_ICONEXCLAMATION);
           return;
        }
        
        char mID;
   
        //Get Module ID //
        TCP_GetModuleID( edtIPAddress->Text.c_str(),&mID);
        edtDeviceID->Text=(int) mID;


        wStartAddress=StrToInt(edtStartAddress->Text);
        wCount=StrToInt(edtCount->Text);
        if( wCount<1 || wCount>16 )
        {
           sprintf(ch,"No. have to between 1 to 16");
           MessageBox(NULL, ch, "EX-9000MTCP demo", MB_OK+MB_ICONEXCLAMATION);
           return;
        }
        for(i=0; i<wCount; i++)
        {
           pEdit=(TEdit *)FindComponent("edtData"+IntToStr(i));
	       wData[i]=StrToInt("0x"+pEdit->Text);
        }
        //--- MODBUS   WriteReg ---
        ReturnValue=TCP_MODBUS_WriteReg(edtIPAddress->Text.c_str(),  wStartAddress, wCount, wData);
        if( ReturnValue )
        {
           sprintf(ch,"TCP_MODBUS_WriteReg() Failure!, Error Code:%d",ReturnValue);
           MessageBox(NULL, ch, "EX-9000MTCP demo", MB_OK+MB_ICONEXCLAMATION);
           return;
        }


}
//---------------------------------------------------------------------------
void __fastcall TForm1::btnExitClick(TObject *Sender)
{
    //------- Disconnect to EX-9000MTCP -------
    TCP_Disconnect();
    Close();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
    int          DLLVersion,ReturnValue;
    char         szDump[80];
    //-------- Initial DLL to working ------
    DLLVersion=TCP_GetDLLVersion();
    edtVersion->Text=IntToHex(DLLVersion,4);
    ReturnValue=TCP_Open();
    if( ReturnValue<0 )
    {
       sprintf(szDump,"TCP_Open() Failure !!!   code=%d\n",ReturnValue);
       MessageBox(NULL, szDump, "5000/TCP demo", MB_OK+MB_ICONEXCLAMATION);
     }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormClose(TObject *Sender, TCloseAction &Action)
{
    //------- Disconnect to EX-9000MTCP -------
    TCP_Disconnect();
    TCP_Close();
}
//---------------------------------------------------------------------------

