//-------------------- demo ------------------------------------//
#include <vcl.h>
#pragma hdrstop

#include <stdio.h>
#include "Unit1.h"
#include <winsock2.h>
#include "..\..\Include\TCPDAQ.H"

#define DEFAULT_PORT 502
//-------- Set timeout value -----
int     iConnectionTimeout=2000;
int     iSendTimeout=2000;
int     iReceiveTimeout=2000;

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------


void __fastcall TForm1::btnReadClick(TObject *Sender)
{
        int          i,j;
        int          iTotalCount,iStartTick,iEndTick;
        int          ReturnValue,DLLVersion;
        WORD         wStartAddress;
        WORD         wCount;
        WORD         wData[64];
        char         ch[80];
        AnsiString   s1;
        SOCKET sock;
        //--- Connect to EX-9000MTCP ---
        ReturnValue=TCP_Connect(edtIPAddress->Text.c_str(),DEFAULT_PORT,iConnectionTimeout, iSendTimeout, iReceiveTimeout);
        if( ReturnValue<0 )
        {
           sprintf(ch,"TCP_Connect() Failure!, Error Code:%d",ReturnValue);
           MessageBox(NULL, ch, "EX-9000MTCP demo", MB_OK+MB_ICONEXCLAMATION);
           return;
        }

        char mID;
   
        //Get Module ID //
        TCP_GetModuleID( edtIPAddress->Text.c_str(),&mID);
        edtDeviceID->Text=(int) mID;


        wStartAddress=StrToInt(edtStartAddress->Text);
        wCount=StrToInt(edtCount->Text);
        if( wCount<1 || wCount>64 )
        {
           sprintf(ch,"No. have to between 1 to 64");
           MessageBox(NULL, ch, "EX-9000MTCP demo", MB_OK+MB_ICONEXCLAMATION);
           return;

        }
        
        for(i=0; i<wCount; i++)
           wData[i]=0x1234;
        //--- reading register ---
        iTotalCount=0;
        iStartTick=GetTickCount();
        do
        {
           ReturnValue=TCP_MODBUS_ReadReg(edtIPAddress->Text.c_str(),wStartAddress, wCount, wData);
           if( ReturnValue<0 )
           {
              sprintf(ch,"TCP_MODBUS_ReadReg() Failure!, Error Code:%d",ReturnValue);
              MessageBox(NULL, ch, "EX-9000MTCP demo", MB_OK+MB_ICONEXCLAMATION);
              return;

           }
           iTotalCount++;
           iEndTick=GetTickCount();
        }while( iEndTick<iStartTick+5000);
        iTotalCount/=5;
        
        memoMsg->Lines->Clear();
        s1.sprintf("Reading register %d times per seconds",iTotalCount);
        memoMsg->Lines->Add( s1 );
        for(i=0,j=wStartAddress; i<wCount; i++,j++)
        {
           memoMsg->Lines->Add(s1.sprintf("Address:%d   Value:%04x[hex]   Value:%d",j,wData[i],wData[i]));
        }


}
//---------------------------------------------------------------------------
void __fastcall TForm1::btnExitClick(TObject *Sender)
{
    //------- Disconnect to EX-9000MTCP -------
    TCP_Disconnect();
    Close();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
    int          DLLVersion,ReturnValue;
    char         szDump[80];
     //-------- Initial DLL to working ------
    DLLVersion=TCP_GetDLLVersion();
    edtVersion->Text=IntToHex(DLLVersion,4);
    ReturnValue=TCP_Open();
    if( ReturnValue<0 )
    {
       sprintf(szDump,"TCP_Open() Failure !!!   code=%d\n",ReturnValue);
       MessageBox(NULL, szDump, "EX-9000MTCP demo", MB_OK+MB_ICONEXCLAMATION);
       return;
    }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormClose(TObject *Sender, TCloseAction &Action)
{
   //------- Disconnect to EX-9000MTCP -------
    TCP_Disconnect();
    TCP_Close();
}
//---------------------------------------------------------------------------


